{
*****************************
*                           *
* Author: Adrian M. Hanslik *
* Date: 31. October 1999    *
* Title: AMHWallPaperBMP    *
* Version: 1.0              *
*                           *
*****************************
}

unit AMHWallPaperBMP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TAMHWallPaperBMP = class(TGraphicControl)
  private
    { Private-Deklarationen }
    FImage: TBitmap;
    procedure SetImage(Value: TBitmap);
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
  published
    { Published-Deklarationen }
    property Align default alClient;
    property Bitmap: TBitmap read FImage write SetImage;
    property Height default 100;
    property Width  default 100;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('AMH Free', [TAMHWallPaperBMP]);
end;

constructor TAMHWallPaperBMP.Create(AnOwner: TComponent);
begin
  inherited Create(AnOwner);
  ControlStyle := ControlStyle + [csOpaque];
  Align := alClient;
  FImage := TBitMap.Create;
end;

destructor TAMHWallPaperBMP.Destroy;
begin
  FImage.Free;
  inherited Destroy;
end;

procedure TAMHWallPaperBMP.Paint;
var
  Buffer: TBitmap;
  X, Y: Integer;
begin
  Buffer := TBitmap.Create;
  try
    Buffer.Height := Height;
    Buffer.Width := Width;
    if FImage.Width > 0 then begin
       Y := 0;
       while Y < Height do begin
             X := 0;
             while X < Width do begin
                   BitBlt(Buffer.Canvas.Handle, X, Y, FImage.Width, FImage.Height, FImage.Canvas.Handle, 0, 0, SrcCopy);
                   Inc(X, FImage.Width);
             end;
             Inc(Y, FImage.Height);
       end;
       BitBlt(Canvas.Handle, 0, 0, Width,Height, Buffer.Canvas.Handle, 0, 0, SrcCopy);
    end;
  finally
    Buffer.Free;
  end;
end;

procedure TAMHWallPaperBMP.SetImage(Value: TBitmap);
begin
  if Assigned(Value) then FImage.Assign(Value)
  else begin
         FImage.Height := 0;
         FImage.Width  := 0;
  end;
  Invalidate;
end;

end.
